//+------------------------------------------------------------------+
//|                                                  my_grid_001.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

extern int Step = 50;

extern int plus_vniz = 300;
extern int vpravo = 300;
double upprice, dnprice, tick;
int okruglenie;
bool uporder; //  ,   ,   
//int i=0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   okruglenie = Digits-1;
   if(Digits == 3 || Digits == 5)
   {
     okruglenie  = Digits-2;
   }   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ObjectsDeleteAll();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
    tick = MarketInfo(Symbol(),MODE_BID); //   bid=1,11549  bid=1,11599
//+---------------
    upprice = NormalizeDouble(tick,okruglenie); //   1,11500
     //        
     if(upprice < Bid+(0.5*Step*Point)) {upprice = NormalizeDouble(tick,okruglenie)+Step*Point;} //    1,11550
     if(upprice < Bid+(0.5*Step*Point)) {upprice = NormalizeDouble(tick,okruglenie)+Step*2*Point;} //    1,11600

    dnprice = NormalizeDouble(tick,okruglenie);
     if(dnprice > Bid-(0.5*Step*Point)) {dnprice = NormalizeDouble(tick,okruglenie)-Step*Point;}
     if(dnprice > Bid-(0.5*Step*Point)) {upprice = NormalizeDouble(tick,okruglenie)-Step*2*Point;}
   // ,   ,  ,      ?
   if(upprice < dnprice) return;
   
   //    ,    
   upprice = NormalizeDouble(upprice,Digits);
   dnprice = NormalizeDouble(dnprice,Digits);
   
   drawline("LineUP", DeepSkyBlue, upprice);
   drawline("LineDN", Red, dnprice);
   drawObject(upprice, 120, DoubleToStr(1,0), Blue);
   drawObject(dnprice, 140, DoubleToStr(2,0), Red);
//+---------------
   uporder = ExistPosByPrice(Symbol(), -1, -1, upprice); //     upprice
   Alert(DoubleToStr(uporder,Digits)+" "+DoubleToStr(upprice,Digits));
   if(uporder) //   ,    
   {
    drawObject(upprice, 160, DoubleToStr(3,0), BlueViolet);
    return;
   }
   if(!uporder) // ,   ,  
   {
      drawObject(0, 160, DoubleToStr(3,0), Red);
      uporder = 1;
      SetNewStopOrder(OP_BUYSTOP, upprice);
      return;
   }
  }
//+------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -            (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//|    pp -                        ( 0   -  )                     |
//+----------------------------------------------------------------------------+
bool ExistPosByPrice(string sy="", int op=-1, int mn=-1, double pp=0) {
  double px, py;
  int    d, i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            //d=MarketInfo(OrderSymbol(), MODE_DIGITS);
            d=Digits;
            px=NormalizeDouble(pp, d);
            py=NormalizeDouble(OrderOpenPrice(), d);
            if (pp<=0 || px==py) return(True);
          }
        }
      }
    }
  }
  return(False);
}
//+------------------------------------------------------------------+
//    
double drawObject(double txt, int vniz, string objname, color clr)
{
   string txt1 = DoubleToStr(txt,Digits);
   ObjectCreate("1455"+objname, OBJ_LABEL,0,0,1.0);
   ObjectSetText("1455"+objname,txt1,10, "Arial Black", clr);
   ObjectSet("1455"+objname, OBJPROP_CORNER, 1);
   ObjectSet("1455"+objname, OBJPROP_XDISTANCE, vpravo);
   ObjectSet("1455"+objname, OBJPROP_YDISTANCE, vniz+plus_vniz);
   return(0);
}
//+------------------------------------------------------------------+
//     
int drawline(string NameL, color col, double Y1)
{
   ObjectDelete(NameL); //   ,    
   
   ObjectCreate(NameL, OBJ_HLINE, 0,0,Y1,0,0);
   ObjectSet   (NameL, OBJPROP_COLOR, col);
   ObjectSet   (NameL, OBJPROP_STYLE, STYLE_DASHDOTDOT);
   ObjectSet   (NameL, OBJPROP_WIDTH, 1);
   ObjectSet   (NameL, OBJPROP_BACK,  false);
   ObjectSet   (NameL, OBJPROP_RAY,   false);
   return(0);
}
//+------------------------------------------------------------------+

void SetNewStopOrder(int pos, double opprice)
{
  int ticket = OrderSend(Symbol(),pos,0.01,NormalizeDouble(opprice,Digits),10,0,0,NULL,0,0,Blue);
   if(ticket<0) 
     { 
      Print("OrderSend    #",GetLastError());
      //drawObject(GetLastError(), 180, DoubleToStr(4,0), Blue);
  //    return; 
     } 
   else if(ticket>0)
     {
      Print(" OrderSend  ");
      //drawObject(0, 200, DoubleToStr(5,0), Blue);
 //     return;
     }

  //return;
}
